#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <netinet/tcp.h>
#include <netdb.h>
#include <time.h> 

#define BUF_SIZE 256

int main(int argc, char *argv[])
{
	struct sockaddr_in serv_addr, cli_addr;
	int portno;
	char buffer[BUF_SIZE];
	int flags=1;
	time_t timer;
	struct tm* t;

	if(argc < 2) { fprintf(stderr, "Error: no port\n"); exit(0); }
	
	int sfd = socket(AF_INET, SOCK_STREAM, 0);
	if(sfd < 0) { perror("ERROR: socket()"); exit(0); }

	flags = 10;
	if (setsockopt(sfd, SOL_TCP, TCP_KEEPIDLE, (void *)&flags, sizeof(flags))) { perror("ERROR: setsocketopt(), SO_KEEPIDLE"); exit(0); };
	flags = 5;
	if (setsockopt(sfd, SOL_TCP, TCP_KEEPCNT, (void *)&flags, sizeof(flags))) { perror("ERROR: setsocketopt(), SO_KEEPCNT"); exit(0); };
	flags = 5;
	if (setsockopt(sfd, SOL_TCP, TCP_KEEPINTVL, (void *)&flags, sizeof(flags))) { perror("ERROR: setsocketopt(), SO_KEEPINTVL"); exit(0); };

	bzero((char *)&serv_addr, sizeof(serv_addr));
	portno = atoi(argv[1]);
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = INADDR_ANY;
	serv_addr.sin_port = htons(portno);

	if (bind(sfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0) { perror("ERROR: bind()"); exit(0); }
	listen(sfd, 5);
	while(1) {
		int clilen = sizeof(cli_addr);
		int rfd = accept(sfd, (struct sockaddr *)&cli_addr, &clilen);
		if(rfd < 0) { perror("ERROR: accept()"); exit(0); }
		else {
			fprintf(stdout, "accepted..\n");
		}

		while(1) {
			flags =1;
			if (setsockopt(rfd, SOL_SOCKET, SO_KEEPALIVE, (void *)&flags, sizeof(flags))) { perror("ERROR: setsocketopt(), SO_KEEPALIVE"); exit(0); };

			int n = read(rfd, buffer, BUF_SIZE);
			if(n <= 0) {
				FILE *fp=NULL;
				if ((fp = fopen("logfile.txt", "a")) == NULL) {
					printf("fopen error\n");
				} else {
					timer = time(NULL);
					t = localtime(&timer);
					fprintf(fp, "[%d:%d:%d] read() ends\n", t->tm_hour, t->tm_min, t->tm_sec);
					fclose(fp);
				}

				printf("read() ends\n");
				break;
			}

			printf("received: %s\n", buffer);
			snprintf(buffer, BUF_SIZE, "got it");
			n = write(rfd, buffer, BUF_SIZE);
			if (n < 0) { perror("ERROR: write()"); exit(0); }
		}
	}

	return 0;
}
